Package org.opensaml.saml.saml2.metadata

# Interface SPSSODescriptor

All Superinterfaces:
  `AttributeExtensibleXMLObject`, `CacheableSAMLObject`, `RoleDescriptor`, `SAMLObject`, `SignableSAMLObject`, `SignableXMLObject`, `SSODescriptor`, `TimeBoundSAMLObject`, `XMLObject`

All Known Implementing Classes:
  `SPSSODescriptorImpl`

public interface SPSSODescriptor extends SSODescriptor
SAML 2.0 Metadata SPSSODescriptorType.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`AUTH_REQUESTS_SIGNED_ATTRIB_NAME`
"AuthnRequestsSigned" attribute's local name.
`static final String`
`DEFAULT_ELEMENT_LOCAL_NAME`
Element name, no namespace.
`static final QName`
`DEFAULT_ELEMENT_NAME`
Default element name.
`static final String`
`TYPE_LOCAL_NAME`
Local name of the XSI type.
`static final QName`
`TYPE_NAME`
QName of the XSI type.
`static final String`
`WANT_ASSERTIONS_SIGNED_ATTRIB_NAME`
"WantAssertionsSigned" attribute's local name.

### Fields inherited from interface org.opensaml.saml.saml2.common.CacheableSAMLObject

`CACHE_DURATION_ATTRIB_NAME, CACHE_DURATION_ATTRIB_QNAME`

### Fields inherited from interface org.opensaml.saml.saml2.metadata.RoleDescriptor

`ERROR_URL_ATTRIB_NAME, ID_ATTRIB_NAME, PROTOCOL_ENUMERATION_ATTRIB_NAME`

### Fields inherited from interface org.opensaml.saml.saml2.common.TimeBoundSAMLObject

`VALID_UNTIL_ATTRIB_NAME, VALID_UNTIL_ATTRIB_QNAME`

## Method Summary

Modifier and Type
Method
Description
`List<AssertionConsumerService>`
`getAssertionConsumerServices()`
Gets a list of assertion consumer service `Endpoint`s for this service.
`List<AttributeConsumingService>`
`getAttributeConsumingServices()`
Gets a list of attribute consuming service descriptors for this service.
`AssertionConsumerService`
`getDefaultAssertionConsumerService()`
Gets the default assertion consumer service.
`AttributeConsumingService`
`getDefaultAttributeConsumingService()`
Gets the default attribute consuming service.
`Boolean`
`getWantAssertionsSigned()`
Gets whether this service wants assertions signed.
`XSBooleanValue`
`getWantAssertionsSignedXSBoolean()`
Gets whether this service wants assertions signed.
`Boolean`
`isAuthnRequestsSigned()`
Gets whether this service signs AuthN requests.
`XSBooleanValue`
`isAuthnRequestsSignedXSBoolean()`
Gets whether this service signs AuthN requests.
`void`
`setAuthnRequestsSigned(Boolean newIsSigned)`
Sets whether this service signs AuthN requests.
`void`
`setAuthnRequestsSigned(XSBooleanValue newIsSigned)`
Sets whether this service signs AuthN requests.
`void`
`setWantAssertionsSigned(Boolean newWantAssestionSigned)`
Sets whether this service wants assertions signed.
`void`
`setWantAssertionsSigned(XSBooleanValue newWantAssestionSigned)`
Sets whether this service wants assertions signed.

### Methods inherited from interface org.opensaml.core.xml.AttributeExtensibleXMLObject

`getUnknownAttributes`

### Methods inherited from interface org.opensaml.saml.saml2.common.CacheableSAMLObject

`getCacheDuration, setCacheDuration`

### Methods inherited from interface org.opensaml.saml.saml2.metadata.RoleDescriptor

`addSupportedProtocol, getContactPersons, getEndpoints, getEndpoints, getErrorURL, getExtensions, getID, getKeyDescriptors, getOrganization, getSupportedProtocols, isSupportedProtocol, removeAllSupportedProtocols, removeSupportedProtocol, removeSupportedProtocols, setErrorURL, setExtensions, setID, setOrganization`

### Methods inherited from interface org.opensaml.saml.common.SignableSAMLObject

`getSignatureReferenceID`

### Methods inherited from interface org.opensaml.xmlsec.signature.SignableXMLObject

`getSignature, isSigned, setSignature`

### Methods inherited from interface org.opensaml.saml.saml2.metadata.SSODescriptor

`getArtifactResolutionServices, getDefaultArtifactResolutionService, getManageNameIDServices, getNameIDFormats, getSingleLogoutServices`

### Methods inherited from interface org.opensaml.saml.saml2.common.TimeBoundSAMLObject

`getValidUntil, isValid, setValidUntil`

### Methods inherited from interface org.opensaml.core.xml.XMLObject

`detach, ensureDOM, getDOM, getElementQName, getIDIndex, getNamespaceManager, getNamespaces, getNoNamespaceSchemaLocation, getObjectMetadata, getOrderedChildren, getParent, getSchemaLocation, getSchemaType, hasChildren, hasParent, isNil, isNilXSBoolean, releaseChildrenDOM, releaseDOM, releaseParentDOM, resolveID, resolveIDFromRoot, setDOM, setNil, setNil, setNoNamespaceSchemaLocation, setParent, setSchemaLocation`

## Field Details

### DEFAULT_ELEMENT_LOCAL_NAME

@Nonnull @NotEmpty static final String DEFAULT_ELEMENT_LOCAL_NAME
Element name, no namespace.

See Also:
  - Constant Field Values

### DEFAULT_ELEMENT_NAME

@Nonnull static final QName DEFAULT_ELEMENT_NAME
Default element name.

### TYPE_LOCAL_NAME

@Nonnull @NotEmpty static final String TYPE_LOCAL_NAME
Local name of the XSI type.

See Also:
  - Constant Field Values

### TYPE_NAME

@Nonnull static final QName TYPE_NAME
QName of the XSI type.

### AUTH_REQUESTS_SIGNED_ATTRIB_NAME

@Nonnull @NotEmpty static final String AUTH_REQUESTS_SIGNED_ATTRIB_NAME
"AuthnRequestsSigned" attribute's local name.

See Also:
  - Constant Field Values

### WANT_ASSERTIONS_SIGNED_ATTRIB_NAME

@Nonnull @NotEmpty static final String WANT_ASSERTIONS_SIGNED_ATTRIB_NAME
"WantAssertionsSigned" attribute's local name.

See Also:
  - Constant Field Values

## Method Details

### isAuthnRequestsSigned

@Nullable Boolean isAuthnRequestsSigned()
Gets whether this service signs AuthN requests.

Returns:
  true of this service signs requests, false if not

### isAuthnRequestsSignedXSBoolean

@Nullable XSBooleanValue isAuthnRequestsSignedXSBoolean()
Gets whether this service signs AuthN requests.

Returns:
  true of this service signs requests, false if not

### setAuthnRequestsSigned

void setAuthnRequestsSigned(@Nullable Boolean newIsSigned)
Sets whether this service signs AuthN requests. Boolean values will be marshalled to either "true" or "false".

Parameters:
  `newIsSigned` - true of this service signs requests, false if not

### setAuthnRequestsSigned

void setAuthnRequestsSigned(@Nullable XSBooleanValue newIsSigned)
Sets whether this service signs AuthN requests.

Parameters:
  `newIsSigned` - true of this service signs requests, false if not

### getWantAssertionsSigned

@Nullable Boolean getWantAssertionsSigned()
Gets whether this service wants assertions signed.

Returns:
  true if this service wants assertions signed, false if not

### getWantAssertionsSignedXSBoolean

@Nullable XSBooleanValue getWantAssertionsSignedXSBoolean()
Gets whether this service wants assertions signed.

Returns:
  true if this service wants assertions signed, false if not

### setWantAssertionsSigned

void setWantAssertionsSigned(@Nullable Boolean newWantAssestionSigned)
Sets whether this service wants assertions signed. Boolean values will be marshalled to either "true" or "false".

Parameters:
  `newWantAssestionSigned` - true if this service wants assertions signed, false if not

### setWantAssertionsSigned

void setWantAssertionsSigned(@Nullable XSBooleanValue newWantAssestionSigned)
Sets whether this service wants assertions signed.

Parameters:
  `newWantAssestionSigned` - true if this service wants assertions signed, false if not

### getAssertionConsumerServices

@Nonnull @Live List<AssertionConsumerService> getAssertionConsumerServices()
Gets a list of assertion consumer service `Endpoint`s for this service.

Returns:
  list of assertion consumer service `Endpoint`s for this service

### getDefaultAssertionConsumerService

@Nullable AssertionConsumerService getDefaultAssertionConsumerService()
Gets the default assertion consumer service.

The selection algorithm used is:

1. Select the first service with an explicit `isDefault=true`
2. Select the first service with no explicit `isDefault`
3. Select the first service

Returns:
  default assertion consumer service (or null if there are no assertion consumer services defined)

### getAttributeConsumingServices

@Nonnull @Live List<AttributeConsumingService> getAttributeConsumingServices()
Gets a list of attribute consuming service descriptors for this service.

Returns:
  list of attribute consuming service descriptors for this service

### getDefaultAttributeConsumingService

@Nullable AttributeConsumingService getDefaultAttributeConsumingService()
Gets the default attribute consuming service.

The selection algorithm used is:

1. Select the first service with an explicit `isDefault=true`
2. Select the first service with no explicit `isDefault`
3. Select the first service

Returns:
  default attribute consuming service (or null if there are no attribute consuming services defined)